import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

import '../../mvvm_bloc.dart';
import 'counter.view.dart';
import 'counter.vm.dart';

class CounterWidget extends StatelessWidget with ControllerWidget<CounterVM> {
  final int id;
  final void Function(int n) notifyCounterChange;

  CounterWidget({Key key, this.notifyCounterChange, this.id = 1}) : super(key: key);

  @override
  MVVMWidget<CounterVM> render(BuildContext context) {
    return MVVMBLoC(
      view: (context, viewModel) => CounterView(viewModel, id: id),
      viewModel: (lifeCycle) => CounterVM(
        lifeCycle,
        notifyCounterChange: notifyCounterChange,
        id: id,
      ),
    ).build();
  }
}
