import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

import '../../mvvm_bloc.dart';
import 'counter.vm.dart';

class CounterView extends View<CounterVM> {
  final int id;

  CounterView(CounterVM viewModel, {this.id}) : super(viewModel);

  @override
  Widget build(BuildContext context) {
    return Center(
      child: Column(
        mainAxisAlignment: MainAxisAlignment.center,
        children: <Widget>[
          Text(
            'You have pushed the button this many times:',
          ),
          $($vm.counter, builder: (context, counter) {
            return Text(
              '$counter',
              style: Theme.of(context).textTheme.headline4,
            );
          }),
          $if(
            $vm.counter,
            //id: #t2,
            condition: (v) => v % 2 == 0,
            builder: (context, counter) {
              return Text(
                '$counter',
                style: Theme.of(context).textTheme.headline4,
              );
            },
            $else: (context, counter) {
              return Text(
                '---',
                style: Theme.of(context).textTheme.headline4,
              );
            },
          ),
          $else(
            $vm.counter,
            //id: #t3,
            condition: (v) => v % 2 == 0,
            builder: (context, counter) {
              return Text(
                '* $counter',
                style: Theme.of(context).textTheme.headline4,
              );
            },
          ),
          RaisedButton(
            child: Text('-'),
            onPressed: () => $vm.decrement(),
          ),
          RaisedButton(
            child: Text('Goto Page ${id + 1}'),
            onPressed: () => $vm.next(),
          ),
        ],
      ),
    );
  }
}
