import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:flutter_live_data/flutter_live_data.dart';
import 'package:mvvm_bloc_test/events/counter_event.dart';
import 'package:mvvm_bloc_test/ui/my_home_page/homepage.dart';

import '../../main.dart';
import '../../mvvm_bloc.dart';

class CounterVM extends ViewModel {
  final int id;

  CounterVM(
    LifeCycleObserver observer, {
    this.notifyCounterChange,
    this.id,
  }) : this.counter = LiveData(1).bind(observer).asBroadcast(); //.asMultiStream();

  final LiveData<int> counter;

  final void Function(int n) notifyCounterChange;

  void increment() {
    counter.value += 1;
    notifyCounterChange?.call(counter.value);
    eventBus.fire(CounterEvent(counter.value));
  }

  void decrement() {
    counter.value -= 1;
    notifyCounterChange?.call(counter.value);
    eventBus.fire(CounterEvent(counter.value));
  }

  void next() {
    Navigator.push(context, MaterialPageRoute(
      builder: (context) => MyHomePage(id: id + 1),
    ));
  }

  void onInit() {
    print('[$id] on-init $context');
  }

  void onBuild() {
    print('[$id] on-build $context');
  }

  void onDispose() {
    print('[$id] on-dispose $context');
  }

  void onResume() {
    print('[$id] on-resume $context');
  }

  void onPause() {
    print('[$id] on-pause $context');
  }

  void onInactive() {
    print('[$id] on-inactivate $context');
  }

  void onDetach() {
    print('[$id] on-detach  $context');
  }
}
