import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:flutter_live_data/core.dart';
import 'package:mvvm_bloc_test/events/counter_event.dart';
import 'package:mvvm_bloc_test/ui/counter/counter.dart';
import 'package:mvvm_bloc_test/ui/counter/counter.vm.dart';

import '../../mvvm_bloc.dart';
import 'homepage.vm.dart';


class MyHomePageView extends View<MyHomePageVM> {

  final int id;

  MyHomePageView(MyHomePageVM viewModel, {this.id}) : super(viewModel);

  void increment() {
    children.widget<CounterWidget>(#counter)?.viewModel?.increment();
    children.vm<CounterVM>(#counter)?.increment();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Row(
          children: <Widget>[
            Text('[$id] '),
            $watch($vm.title, builder: (_, title) => Text('$title')),
            Text('/'),
            $($vm.title2, builder: (_, title) {
              return Text('$title');
            }),
          ],
        ),
      ),
//      body: plug(#counter, CounterWidget()),
      body: CounterWidget(
        id: id,
        notifyCounterChange: (n) {
          $vm.setTitle('n = $n');
        },
      )..plug(this, #counter),
      floatingActionButton: FloatingActionButton(
        onPressed: increment,
        tooltip: 'Increment',
        child: Icon(Icons.add),
      ), // This trailing comma makes auto-formatting nicer for build methods.
    );
  }
}
