import 'package:flutter_live_data/flutter_live_data.dart';
import 'package:mvvm_bloc_test/events/counter_event.dart';

import '../../main.dart';
import '../../mvvm_bloc.dart';

class MyHomePageVM extends ViewModel {
  final int id;
  final LiveData<String> title;
  final LiveData<String> title2;

  MyHomePageVM(LifeCycleObserver observer, {this.id})
      : this.title = LiveData('Test').bind(observer).asBroadcast(),
        this.title2 = LiveData('event').bind(observer); //.asMultiStream();

  void setTitle(String message) {
    title.value = message;
  }

  void setTitle2(String message) {
    title2.value = message;
  }

  void onInit() {
    print('[$id] on-init $context');
  }

  void onBuild() {
    print('[$id] on-build $context');
    eventBus.on<CounterEvent>().listen((event) {
      setTitle2('${event.count}');
      print('event=$event, ${title2.value}');
    });
  }

  void onDispose() {
    print('[$id] on-dispose $context');
  }

  void onResume() {
    print('[$id] on-resume $context');
  }

  void onPause() {
    print('[$id] on-pause $context');
  }

  void onInactive() {
    print('[$id] on-inactivate $context');
  }

  void onDetach() {
    print('[$id] on-detach  $context');
  }
}
